/* ArchiveManager.c generated by valac 0.56.18, the Vala compiler
 * generated from ArchiveManager.vala, do not modify */

/* ArchiveManager.vala
 *
 * Copyright (C) 2009-2025 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <archive.h>
#include <gio/gio.h>
#include <archive_entry.h>
#include <time.h>
#include "font-manager.h"
#include <glib/gstdio.h>
#include <sys/types.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FONT_MANAGER_TYPE_ARCHIVE_MANAGER (font_manager_archive_manager_get_type ())
#define FONT_MANAGER_ARCHIVE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_ARCHIVE_MANAGER, FontManagerArchiveManager))
#define FONT_MANAGER_ARCHIVE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_ARCHIVE_MANAGER, FontManagerArchiveManagerClass))
#define FONT_MANAGER_IS_ARCHIVE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_ARCHIVE_MANAGER))
#define FONT_MANAGER_IS_ARCHIVE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_ARCHIVE_MANAGER))
#define FONT_MANAGER_ARCHIVE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_ARCHIVE_MANAGER, FontManagerArchiveManagerClass))

typedef struct _FontManagerArchiveManager FontManagerArchiveManager;
typedef struct _FontManagerArchiveManagerClass FontManagerArchiveManagerClass;
typedef struct _FontManagerArchiveManagerPrivate FontManagerArchiveManagerPrivate;
enum  {
	FONT_MANAGER_ARCHIVE_MANAGER_0_PROPERTY,
	FONT_MANAGER_ARCHIVE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* font_manager_archive_manager_properties[FONT_MANAGER_ARCHIVE_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _archive_entry_free0(var) ((var == NULL) ? NULL : (var = (archive_entry_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _archive_write_free0(var) ((var == NULL) ? NULL : (var = (archive_write_free (var), NULL)))
#define _archive_read_free0(var) ((var == NULL) ? NULL : (var = (archive_read_free (var), NULL)))

struct _FontManagerArchiveManager {
	GObject parent_instance;
	FontManagerArchiveManagerPrivate * priv;
};

struct _FontManagerArchiveManagerClass {
	GObjectClass parent_class;
};

static gpointer font_manager_archive_manager_parent_class = NULL;

VALA_EXTERN GType font_manager_archive_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerArchiveManager, g_object_unref)
static struct archive_entry* font_manager_archive_manager_add_entry (FontManagerArchiveManager* self,
                                                              struct archive* archive,
                                                              GFile* file,
                                                              GFileInfo* file_info,
                                                              const gchar* path);
static gint64 font_manager_archive_manager_add_data (FontManagerArchiveManager* self,
                                              struct archive* archive,
                                              GFile* file,
                                              GFileInfo* file_info,
                                              const gchar* path);
static void font_manager_archive_manager_add_directory (FontManagerArchiveManager* self,
                                                 struct archive* archive,
                                                 GFile* file,
                                                 GFileInfo* file_info,
                                                 const gchar* path);
VALA_EXTERN gboolean font_manager_archive_manager_compress (FontManagerArchiveManager* self,
                                                FontManagerStringSet* filelist,
                                                GFile* output_file);
VALA_EXTERN gboolean font_manager_archive_manager_extract (FontManagerArchiveManager* self,
                                               GFile* file,
                                               GFile* dest_dir);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
VALA_EXTERN FontManagerArchiveManager* font_manager_archive_manager_new (void);
VALA_EXTERN FontManagerArchiveManager* font_manager_archive_manager_construct (GType object_type);
static GType font_manager_archive_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gchar* FONT_MANAGER_LIBARCHIVE_MIME_TYPES[26] = {"application/epub+zip", "application/vnd.debian.binary-package", "application/vnd.ms-cab-compressed", "application/vnd.rar", "application/x-7z-compressed", "application/x-ar", "application/x-bzip-compressed-tar", "application/x-cbr", "application/x-cbz", "application/x-cd-image", "application/x-compressed-tar", "application/x-cpio", "application/x-deb", "application/x-lha", "application/x-lrzip-compressed-tar", "application/x-lzip-compressed-tar", "application/x-lzma-compressed-tar", "application/x-rar", "application/x-rpm", "application/x-tar", "application/x-tarz", "application/x-tzo", "application/x-xar", "application/x-xz-compressed-tar", "application/x-zstd-compressed-tar", "application/zip"};

static struct archive_entry*
font_manager_archive_manager_add_entry (FontManagerArchiveManager* self,
                                        struct archive* archive,
                                        GFile* file,
                                        GFileInfo* file_info,
                                        const gchar* path)
{
	struct archive_entry* entry = NULL;
	struct archive_entry* _tmp0_;
	struct archive_entry* _tmp1_;
	struct archive_entry* _tmp2_;
	gboolean IFREG = FALSE;
	__LA_MODE_T _tmp3_ = 0;
	struct archive_entry* _tmp4_;
	struct archive_entry* _tmp5_;
	struct archive_entry* _tmp6_;
	struct archive_entry* _tmp7_;
	struct archive_entry* _tmp8_;
	struct archive_entry* _tmp9_;
	struct archive_entry* _tmp10_;
	struct archive_entry* _tmp11_;
	struct archive_entry* _tmp12_;
	struct archive_entry* result;
#line 56 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (archive != NULL, NULL);
#line 56 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 56 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (file_info != NULL, NULL);
#line 56 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 57 "../src/font-manager/ArchiveManager.vala"
	_tmp0_ = archive_entry_new2 (NULL);
#line 57 "../src/font-manager/ArchiveManager.vala"
	entry = _tmp0_;
#line 58 "../src/font-manager/ArchiveManager.vala"
	_tmp1_ = entry;
#line 58 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_pathname (_tmp1_, path);
#line 59 "../src/font-manager/ArchiveManager.vala"
	_tmp2_ = entry;
#line 59 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_size (_tmp2_, (la_int64_t) g_file_info_get_size (file_info));
#line 60 "../src/font-manager/ArchiveManager.vala"
	IFREG = g_file_info_get_file_type (file_info) == G_FILE_TYPE_REGULAR;
#line 61 "../src/font-manager/ArchiveManager.vala"
	if (IFREG) {
#line 61 "../src/font-manager/ArchiveManager.vala"
		_tmp3_ = AE_IFREG;
#line 179 "ArchiveManager.c"
	} else {
#line 61 "../src/font-manager/ArchiveManager.vala"
		_tmp3_ = AE_IFDIR;
#line 183 "ArchiveManager.c"
	}
#line 61 "../src/font-manager/ArchiveManager.vala"
	_tmp4_ = entry;
#line 61 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_filetype (_tmp4_, _tmp3_);
#line 62 "../src/font-manager/ArchiveManager.vala"
	_tmp5_ = entry;
#line 62 "../src/font-manager/ArchiveManager.vala"
	archive_entry_unset_birthtime (_tmp5_);
#line 63 "../src/font-manager/ArchiveManager.vala"
	_tmp6_ = entry;
#line 63 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_atime (_tmp6_, (time_t) g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_TIME_ACCESS), (glong) (g_file_info_get_attribute_uint32 (file_info, G_FILE_ATTRIBUTE_TIME_ACCESS_USEC) * 1000));
#line 65 "../src/font-manager/ArchiveManager.vala"
	_tmp7_ = entry;
#line 65 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_ctime (_tmp7_, (time_t) g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_TIME_CREATED), (glong) (g_file_info_get_attribute_uint32 (file_info, G_FILE_ATTRIBUTE_TIME_CREATED_USEC) * 1000));
#line 67 "../src/font-manager/ArchiveManager.vala"
	_tmp8_ = entry;
#line 67 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_mtime (_tmp8_, (time_t) g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_TIME_MODIFIED), (glong) (g_file_info_get_attribute_uint32 (file_info, G_FILE_ATTRIBUTE_TIME_MODIFIED_USEC) * 1000));
#line 69 "../src/font-manager/ArchiveManager.vala"
	_tmp9_ = entry;
#line 69 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_uid (_tmp9_, (la_int64_t) g_file_info_get_attribute_uint32 (file_info, G_FILE_ATTRIBUTE_UNIX_UID));
#line 70 "../src/font-manager/ArchiveManager.vala"
	_tmp10_ = entry;
#line 70 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_gid (_tmp10_, (la_int64_t) g_file_info_get_attribute_uint32 (file_info, G_FILE_ATTRIBUTE_UNIX_GID));
#line 71 "../src/font-manager/ArchiveManager.vala"
	_tmp11_ = entry;
#line 71 "../src/font-manager/ArchiveManager.vala"
	archive_entry_set_mode (_tmp11_, (__LA_MODE_T) g_file_info_get_attribute_uint32 (file_info, G_FILE_ATTRIBUTE_UNIX_MODE));
#line 72 "../src/font-manager/ArchiveManager.vala"
	_tmp12_ = entry;
#line 72 "../src/font-manager/ArchiveManager.vala"
	if (archive_write_header (archive, _tmp12_) != ARCHIVE_OK) {
#line 221 "ArchiveManager.c"
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 73 "../src/font-manager/ArchiveManager.vala"
		_tmp13_ = g_file_get_path (file);
#line 73 "../src/font-manager/ArchiveManager.vala"
		_tmp14_ = _tmp13_;
#line 73 "../src/font-manager/ArchiveManager.vala"
		_tmp15_ = archive_error_string (archive);
#line 73 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:73: Error adding entry for '%s': %s (%d)", _tmp14_, _tmp15_, archive_errno (archive));
#line 73 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (_tmp14_);
#line 235 "ArchiveManager.c"
	}
#line 74 "../src/font-manager/ArchiveManager.vala"
	result = entry;
#line 74 "../src/font-manager/ArchiveManager.vala"
	return result;
#line 241 "ArchiveManager.c"
}

static gint64
font_manager_archive_manager_add_data (FontManagerArchiveManager* self,
                                       struct archive* archive,
                                       GFile* file,
                                       GFileInfo* file_info,
                                       const gchar* path)
{
	gint64 size = 0LL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	struct archive_entry* _tmp4_;
	struct archive_entry* _tmp5_;
	GError* _inner_error0_ = NULL;
	gint64 result;
#line 77 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 77 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (archive != NULL, 0LL);
#line 77 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (file != NULL, 0LL);
#line 77 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (file_info != NULL, 0LL);
#line 77 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (path != NULL, 0LL);
#line 78 "../src/font-manager/ArchiveManager.vala"
	size = (gint64) 0;
#line 79 "../src/font-manager/ArchiveManager.vala"
	_tmp0_ = g_file_get_basename (file);
#line 79 "../src/font-manager/ArchiveManager.vala"
	_tmp1_ = _tmp0_;
#line 79 "../src/font-manager/ArchiveManager.vala"
	_tmp2_ = g_build_filename (path, _tmp1_, NULL);
#line 79 "../src/font-manager/ArchiveManager.vala"
	_tmp3_ = _tmp2_;
#line 79 "../src/font-manager/ArchiveManager.vala"
	_tmp4_ = font_manager_archive_manager_add_entry (self, archive, file, file_info, _tmp3_);
#line 79 "../src/font-manager/ArchiveManager.vala"
	_tmp5_ = _tmp4_;
#line 79 "../src/font-manager/ArchiveManager.vala"
	_archive_entry_free0 (_tmp5_);
#line 79 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (_tmp3_);
#line 79 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (_tmp1_);
#line 290 "ArchiveManager.c"
	{
		GFileInputStream* input_stream = NULL;
		GFileInputStream* _tmp6_;
		GDataInputStream* data_input_stream = NULL;
		GFileInputStream* _tmp7_;
		GDataInputStream* _tmp8_;
		gsize bytes_read = 0UL;
		guint8* buffer = NULL;
		guint8* _tmp9_;
		gint buffer_length1;
		gint _buffer_size_;
#line 81 "../src/font-manager/ArchiveManager.vala"
		_tmp6_ = g_file_read (file, NULL, &_inner_error0_);
#line 81 "../src/font-manager/ArchiveManager.vala"
		input_stream = _tmp6_;
#line 81 "../src/font-manager/ArchiveManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "ArchiveManager.c"
			goto __catch0_g_error;
		}
#line 82 "../src/font-manager/ArchiveManager.vala"
		_tmp7_ = input_stream;
#line 82 "../src/font-manager/ArchiveManager.vala"
		_tmp8_ = g_data_input_stream_new ((GInputStream*) _tmp7_);
#line 82 "../src/font-manager/ArchiveManager.vala"
		data_input_stream = _tmp8_;
#line 84 "../src/font-manager/ArchiveManager.vala"
		_tmp9_ = g_new0 (guint8, 1024);
#line 84 "../src/font-manager/ArchiveManager.vala"
		buffer = _tmp9_;
#line 84 "../src/font-manager/ArchiveManager.vala"
		buffer_length1 = 1024;
#line 84 "../src/font-manager/ArchiveManager.vala"
		_buffer_size_ = buffer_length1;
#line 85 "../src/font-manager/ArchiveManager.vala"
		while (TRUE) {
#line 327 "ArchiveManager.c"
			gboolean _tmp10_ = FALSE;
			GDataInputStream* _tmp11_;
			guint8* _tmp12_;
			gint _tmp12__length1;
			gsize _tmp13_ = 0UL;
			gboolean _tmp14_;
			guint8* _tmp15_;
			gint _tmp15__length1;
#line 85 "../src/font-manager/ArchiveManager.vala"
			_tmp11_ = data_input_stream;
#line 85 "../src/font-manager/ArchiveManager.vala"
			_tmp12_ = buffer;
#line 85 "../src/font-manager/ArchiveManager.vala"
			_tmp12__length1 = buffer_length1;
#line 85 "../src/font-manager/ArchiveManager.vala"
			_tmp14_ = g_input_stream_read_all ((GInputStream*) _tmp11_, _tmp12_, (gsize) _tmp12__length1, &_tmp13_, NULL, &_inner_error0_);
#line 85 "../src/font-manager/ArchiveManager.vala"
			bytes_read = _tmp13_;
#line 85 "../src/font-manager/ArchiveManager.vala"
			_tmp10_ = _tmp14_;
#line 85 "../src/font-manager/ArchiveManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/font-manager/ArchiveManager.vala"
				buffer = (g_free (buffer), NULL);
#line 85 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (data_input_stream);
#line 85 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (input_stream);
#line 356 "ArchiveManager.c"
				goto __catch0_g_error;
			}
#line 85 "../src/font-manager/ArchiveManager.vala"
			if (!_tmp10_) {
#line 85 "../src/font-manager/ArchiveManager.vala"
				break;
#line 363 "ArchiveManager.c"
			}
#line 86 "../src/font-manager/ArchiveManager.vala"
			if (bytes_read <= ((gsize) 0)) {
#line 87 "../src/font-manager/ArchiveManager.vala"
				break;
#line 369 "ArchiveManager.c"
			}
#line 88 "../src/font-manager/ArchiveManager.vala"
			_tmp15_ = buffer;
#line 88 "../src/font-manager/ArchiveManager.vala"
			_tmp15__length1 = buffer_length1;
#line 88 "../src/font-manager/ArchiveManager.vala"
			archive_write_data (archive, _tmp15_, (size_t) _tmp15__length1);
#line 89 "../src/font-manager/ArchiveManager.vala"
			size += (gint64) bytes_read;
#line 379 "ArchiveManager.c"
		}
#line 80 "../src/font-manager/ArchiveManager.vala"
		buffer = (g_free (buffer), NULL);
#line 80 "../src/font-manager/ArchiveManager.vala"
		_g_object_unref0 (data_input_stream);
#line 80 "../src/font-manager/ArchiveManager.vala"
		_g_object_unref0 (input_stream);
#line 387 "ArchiveManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 80 "../src/font-manager/ArchiveManager.vala"
		e = _inner_error0_;
#line 80 "../src/font-manager/ArchiveManager.vala"
		_inner_error0_ = NULL;
#line 92 "../src/font-manager/ArchiveManager.vala"
		_tmp16_ = g_file_get_path (file);
#line 92 "../src/font-manager/ArchiveManager.vala"
		_tmp17_ = _tmp16_;
#line 92 "../src/font-manager/ArchiveManager.vala"
		_tmp18_ = archive_error_string (archive);
#line 92 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:92: Error adding data for '%s' : %s (%d)", _tmp17_, _tmp18_, archive_errno (archive));
#line 92 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (_tmp17_);
#line 93 "../src/font-manager/ArchiveManager.vala"
		_tmp19_ = e;
#line 93 "../src/font-manager/ArchiveManager.vala"
		_tmp20_ = _tmp19_->message;
#line 93 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:93: %s", _tmp20_);
#line 80 "../src/font-manager/ArchiveManager.vala"
		_g_error_free0 (e);
#line 420 "ArchiveManager.c"
	}
	__finally0:
#line 80 "../src/font-manager/ArchiveManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 425 "ArchiveManager.c"
		gint64 _tmp21_ = -1LL;
#line 80 "../src/font-manager/ArchiveManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 80 "../src/font-manager/ArchiveManager.vala"
		g_clear_error (&_inner_error0_);
#line 80 "../src/font-manager/ArchiveManager.vala"
		return _tmp21_;
#line 433 "ArchiveManager.c"
	}
#line 95 "../src/font-manager/ArchiveManager.vala"
	result = size;
#line 95 "../src/font-manager/ArchiveManager.vala"
	return result;
#line 439 "ArchiveManager.c"
}

static void
font_manager_archive_manager_add_directory (FontManagerArchiveManager* self,
                                            struct archive* archive,
                                            GFile* file,
                                            GFileInfo* file_info,
                                            const gchar* path)
{
	gchar* root = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	struct archive_entry* _tmp5_;
	struct archive_entry* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 98 "../src/font-manager/ArchiveManager.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/font-manager/ArchiveManager.vala"
	g_return_if_fail (archive != NULL);
#line 98 "../src/font-manager/ArchiveManager.vala"
	g_return_if_fail (file != NULL);
#line 98 "../src/font-manager/ArchiveManager.vala"
	g_return_if_fail (file_info != NULL);
#line 98 "../src/font-manager/ArchiveManager.vala"
	g_return_if_fail (path != NULL);
#line 99 "../src/font-manager/ArchiveManager.vala"
	_tmp0_ = g_file_get_basename (file);
#line 99 "../src/font-manager/ArchiveManager.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/font-manager/ArchiveManager.vala"
	_tmp2_ = g_build_filename (path, _tmp1_, NULL);
#line 99 "../src/font-manager/ArchiveManager.vala"
	_tmp3_ = _tmp2_;
#line 99 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (_tmp1_);
#line 99 "../src/font-manager/ArchiveManager.vala"
	root = _tmp3_;
#line 100 "../src/font-manager/ArchiveManager.vala"
	_tmp4_ = root;
#line 100 "../src/font-manager/ArchiveManager.vala"
	_tmp5_ = font_manager_archive_manager_add_entry (self, archive, file, file_info, _tmp4_);
#line 100 "../src/font-manager/ArchiveManager.vala"
	_tmp6_ = _tmp5_;
#line 100 "../src/font-manager/ArchiveManager.vala"
	_archive_entry_free0 (_tmp6_);
#line 488 "ArchiveManager.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp7_;
		GFileInfo* child_info = NULL;
		GFileEnumerator* _tmp8_;
		GFileInfo* _tmp9_;
#line 102 "../src/font-manager/ArchiveManager.vala"
		_tmp7_ = g_file_enumerate_children (file, "*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 102 "../src/font-manager/ArchiveManager.vala"
		enumerator = _tmp7_;
#line 102 "../src/font-manager/ArchiveManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 501 "ArchiveManager.c"
			goto __catch0_g_error;
		}
#line 103 "../src/font-manager/ArchiveManager.vala"
		_tmp8_ = enumerator;
#line 103 "../src/font-manager/ArchiveManager.vala"
		_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 103 "../src/font-manager/ArchiveManager.vala"
		child_info = _tmp9_;
#line 103 "../src/font-manager/ArchiveManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "../src/font-manager/ArchiveManager.vala"
			_g_object_unref0 (enumerator);
#line 514 "ArchiveManager.c"
			goto __catch0_g_error;
		}
#line 104 "../src/font-manager/ArchiveManager.vala"
		while (TRUE) {
#line 519 "ArchiveManager.c"
			GFileInfo* _tmp10_;
			GFileType child_type = 0;
			GFileInfo* _tmp11_;
			GFile* child = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			GFile* _tmp14_;
			GFileInfo* _tmp21_ = NULL;
			GFileEnumerator* _tmp22_;
			GFileInfo* _tmp23_;
			GFileInfo* _tmp24_;
#line 104 "../src/font-manager/ArchiveManager.vala"
			_tmp10_ = child_info;
#line 104 "../src/font-manager/ArchiveManager.vala"
			if (!(_tmp10_ != NULL)) {
#line 104 "../src/font-manager/ArchiveManager.vala"
				break;
#line 537 "ArchiveManager.c"
			}
#line 105 "../src/font-manager/ArchiveManager.vala"
			_tmp11_ = child_info;
#line 105 "../src/font-manager/ArchiveManager.vala"
			child_type = g_file_info_get_file_type (_tmp11_);
#line 106 "../src/font-manager/ArchiveManager.vala"
			_tmp12_ = child_info;
#line 106 "../src/font-manager/ArchiveManager.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 106 "../src/font-manager/ArchiveManager.vala"
			_tmp14_ = g_file_get_child (file, _tmp13_);
#line 106 "../src/font-manager/ArchiveManager.vala"
			child = _tmp14_;
#line 107 "../src/font-manager/ArchiveManager.vala"
			if (child_type == G_FILE_TYPE_DIRECTORY) {
#line 553 "ArchiveManager.c"
				GFile* _tmp15_;
				GFileInfo* _tmp16_;
				const gchar* _tmp17_;
#line 108 "../src/font-manager/ArchiveManager.vala"
				_tmp15_ = child;
#line 108 "../src/font-manager/ArchiveManager.vala"
				_tmp16_ = child_info;
#line 108 "../src/font-manager/ArchiveManager.vala"
				_tmp17_ = root;
#line 108 "../src/font-manager/ArchiveManager.vala"
				font_manager_archive_manager_add_directory (self, archive, _tmp15_, _tmp16_, _tmp17_);
#line 565 "ArchiveManager.c"
			} else {
#line 109 "../src/font-manager/ArchiveManager.vala"
				if (child_type == G_FILE_TYPE_REGULAR) {
#line 569 "ArchiveManager.c"
					GFile* _tmp18_;
					GFileInfo* _tmp19_;
					const gchar* _tmp20_;
#line 110 "../src/font-manager/ArchiveManager.vala"
					_tmp18_ = child;
#line 110 "../src/font-manager/ArchiveManager.vala"
					_tmp19_ = child_info;
#line 110 "../src/font-manager/ArchiveManager.vala"
					_tmp20_ = root;
#line 110 "../src/font-manager/ArchiveManager.vala"
					font_manager_archive_manager_add_data (self, archive, _tmp18_, _tmp19_, _tmp20_);
#line 581 "ArchiveManager.c"
				}
			}
#line 111 "../src/font-manager/ArchiveManager.vala"
			_tmp22_ = enumerator;
#line 111 "../src/font-manager/ArchiveManager.vala"
			_tmp23_ = g_file_enumerator_next_file (_tmp22_, NULL, &_inner_error0_);
#line 111 "../src/font-manager/ArchiveManager.vala"
			_tmp21_ = _tmp23_;
#line 111 "../src/font-manager/ArchiveManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (child);
#line 111 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (child_info);
#line 111 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (enumerator);
#line 598 "ArchiveManager.c"
				goto __catch0_g_error;
			}
#line 111 "../src/font-manager/ArchiveManager.vala"
			_tmp24_ = _tmp21_;
#line 111 "../src/font-manager/ArchiveManager.vala"
			_tmp21_ = NULL;
#line 111 "../src/font-manager/ArchiveManager.vala"
			_g_object_unref0 (child_info);
#line 111 "../src/font-manager/ArchiveManager.vala"
			child_info = _tmp24_;
#line 104 "../src/font-manager/ArchiveManager.vala"
			_g_object_unref0 (_tmp21_);
#line 104 "../src/font-manager/ArchiveManager.vala"
			_g_object_unref0 (child);
#line 613 "ArchiveManager.c"
		}
#line 101 "../src/font-manager/ArchiveManager.vala"
		_g_object_unref0 (child_info);
#line 101 "../src/font-manager/ArchiveManager.vala"
		_g_object_unref0 (enumerator);
#line 619 "ArchiveManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		GError* _tmp28_;
		const gchar* _tmp29_;
#line 101 "../src/font-manager/ArchiveManager.vala"
		e = _inner_error0_;
#line 101 "../src/font-manager/ArchiveManager.vala"
		_inner_error0_ = NULL;
#line 114 "../src/font-manager/ArchiveManager.vala"
		_tmp25_ = g_file_get_path (file);
#line 114 "../src/font-manager/ArchiveManager.vala"
		_tmp26_ = _tmp25_;
#line 114 "../src/font-manager/ArchiveManager.vala"
		_tmp27_ = archive_error_string (archive);
#line 114 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:114: Error adding directory '%s' : %s (%d)", _tmp26_, _tmp27_, archive_errno (archive));
#line 114 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (_tmp26_);
#line 115 "../src/font-manager/ArchiveManager.vala"
		_tmp28_ = e;
#line 115 "../src/font-manager/ArchiveManager.vala"
		_tmp29_ = _tmp28_->message;
#line 115 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:115: %s", _tmp29_);
#line 101 "../src/font-manager/ArchiveManager.vala"
		_g_error_free0 (e);
#line 652 "ArchiveManager.c"
	}
	__finally0:
#line 101 "../src/font-manager/ArchiveManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (root);
#line 101 "../src/font-manager/ArchiveManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../src/font-manager/ArchiveManager.vala"
		g_clear_error (&_inner_error0_);
#line 101 "../src/font-manager/ArchiveManager.vala"
		return;
#line 665 "ArchiveManager.c"
	}
#line 117 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (root);
#line 117 "../src/font-manager/ArchiveManager.vala"
	return;
#line 671 "ArchiveManager.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 690 "ArchiveManager.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 703 "ArchiveManager.c"
}

gboolean
font_manager_archive_manager_compress (FontManagerArchiveManager* self,
                                       FontManagerStringSet* filelist,
                                       GFile* output_file)
{
	guint _tmp0_;
	guint _tmp1_;
	GFile* output_dir = NULL;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	struct archive* archive = NULL;
	struct archive* _tmp9_;
	struct archive* _tmp10_;
	gchar* root = NULL;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* filename = NULL;
	GFile* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	struct archive* _tmp28_;
	const gchar* _tmp29_;
	struct archive* _tmp59_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 120 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (filelist != NULL, FALSE);
#line 120 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (output_file != NULL, FALSE);
#line 122 "../src/font-manager/ArchiveManager.vala"
	g_object_get (filelist, "size", &_tmp0_, NULL);
#line 122 "../src/font-manager/ArchiveManager.vala"
	_tmp1_ = _tmp0_;
#line 122 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (_tmp1_ > ((guint) 0), FALSE);
#line 123 "../src/font-manager/ArchiveManager.vala"
	_tmp2_ = g_file_get_parent (output_file);
#line 123 "../src/font-manager/ArchiveManager.vala"
	_tmp3_ = _tmp2_;
#line 123 "../src/font-manager/ArchiveManager.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 123 "../src/font-manager/ArchiveManager.vala"
	_tmp5_ = _tmp4_;
#line 123 "../src/font-manager/ArchiveManager.vala"
	_tmp6_ = g_file_new_for_path (_tmp5_);
#line 123 "../src/font-manager/ArchiveManager.vala"
	_tmp7_ = _tmp6_;
#line 123 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (_tmp5_);
#line 123 "../src/font-manager/ArchiveManager.vala"
	_g_object_unref0 (_tmp3_);
#line 123 "../src/font-manager/ArchiveManager.vala"
	output_dir = _tmp7_;
#line 124 "../src/font-manager/ArchiveManager.vala"
	_tmp8_ = output_dir;
#line 124 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (g_file_query_exists (_tmp8_, NULL), FALSE);
#line 126 "../src/font-manager/ArchiveManager.vala"
	_tmp9_ = archive_write_new ();
#line 126 "../src/font-manager/ArchiveManager.vala"
	archive = _tmp9_;
#line 127 "../src/font-manager/ArchiveManager.vala"
	_tmp10_ = archive;
#line 127 "../src/font-manager/ArchiveManager.vala"
	archive_write_set_format_zip (_tmp10_);
#line 129 "../src/font-manager/ArchiveManager.vala"
	_tmp11_ = g_file_get_basename (output_file);
#line 129 "../src/font-manager/ArchiveManager.vala"
	root = _tmp11_;
#line 130 "../src/font-manager/ArchiveManager.vala"
	_tmp12_ = root;
#line 130 "../src/font-manager/ArchiveManager.vala"
	if (string_contains (_tmp12_, ".")) {
#line 792 "ArchiveManager.c"
		const gchar* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 131 "../src/font-manager/ArchiveManager.vala"
		_tmp13_ = root;
#line 131 "../src/font-manager/ArchiveManager.vala"
		_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, ".", 0);
#line 131 "../src/font-manager/ArchiveManager.vala"
		_tmp16_ = _tmp15_;
#line 131 "../src/font-manager/ArchiveManager.vala"
		_tmp16__length1 = _vala_array_length (_tmp14_);
#line 131 "../src/font-manager/ArchiveManager.vala"
		_tmp17_ = _tmp16_[0];
#line 131 "../src/font-manager/ArchiveManager.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 131 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (root);
#line 131 "../src/font-manager/ArchiveManager.vala"
		root = _tmp18_;
#line 131 "../src/font-manager/ArchiveManager.vala"
		_tmp16_ = (_vala_array_free (_tmp16_, _tmp16__length1, (GDestroyNotify) g_free), NULL);
#line 818 "ArchiveManager.c"
	}
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp19_ = output_dir;
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp20_ = g_file_get_path (_tmp19_);
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp21_ = _tmp20_;
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp22_ = root;
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp23_ = string_to_string (_tmp22_);
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp24_ = g_strconcat (_tmp23_, ".zip", NULL);
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp25_ = _tmp24_;
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp26_ = g_build_filename (_tmp21_, _tmp25_, NULL);
#line 133 "../src/font-manager/ArchiveManager.vala"
	_tmp27_ = _tmp26_;
#line 133 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (_tmp25_);
#line 133 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (_tmp21_);
#line 133 "../src/font-manager/ArchiveManager.vala"
	filename = _tmp27_;
#line 135 "../src/font-manager/ArchiveManager.vala"
	_tmp28_ = archive;
#line 135 "../src/font-manager/ArchiveManager.vala"
	_tmp29_ = filename;
#line 135 "../src/font-manager/ArchiveManager.vala"
	if (archive_write_open_filename (_tmp28_, _tmp29_) != ARCHIVE_OK) {
#line 850 "ArchiveManager.c"
		gchar* _tmp30_;
		gchar* _tmp31_;
		struct archive* _tmp32_;
		const gchar* _tmp33_;
		struct archive* _tmp34_;
#line 136 "../src/font-manager/ArchiveManager.vala"
		_tmp30_ = g_file_get_path (output_file);
#line 136 "../src/font-manager/ArchiveManager.vala"
		_tmp31_ = _tmp30_;
#line 136 "../src/font-manager/ArchiveManager.vala"
		_tmp32_ = archive;
#line 136 "../src/font-manager/ArchiveManager.vala"
		_tmp33_ = archive_error_string (_tmp32_);
#line 136 "../src/font-manager/ArchiveManager.vala"
		_tmp34_ = archive;
#line 136 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:136: Error opening '%s' : %s (%d)", _tmp31_, _tmp33_, archive_errno (_tmp34_));
#line 136 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (_tmp31_);
#line 137 "../src/font-manager/ArchiveManager.vala"
		result = FALSE;
#line 137 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (filename);
#line 137 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (root);
#line 137 "../src/font-manager/ArchiveManager.vala"
		_archive_write_free0 (archive);
#line 137 "../src/font-manager/ArchiveManager.vala"
		_g_object_unref0 (output_dir);
#line 137 "../src/font-manager/ArchiveManager.vala"
		return result;
#line 882 "ArchiveManager.c"
	}
	{
		FontManagerStringSet* _filepath_list = NULL;
		guint _filepath_size = 0U;
		FontManagerStringSet* _tmp35_;
		guint _tmp36_;
		guint _tmp37_;
		gint _filepath_index = 0;
#line 140 "../src/font-manager/ArchiveManager.vala"
		_filepath_list = filelist;
#line 140 "../src/font-manager/ArchiveManager.vala"
		_tmp35_ = _filepath_list;
#line 140 "../src/font-manager/ArchiveManager.vala"
		g_object_get (_tmp35_, "size", &_tmp36_, NULL);
#line 140 "../src/font-manager/ArchiveManager.vala"
		_tmp37_ = _tmp36_;
#line 140 "../src/font-manager/ArchiveManager.vala"
		_filepath_size = _tmp37_;
#line 140 "../src/font-manager/ArchiveManager.vala"
		_filepath_index = -1;
#line 140 "../src/font-manager/ArchiveManager.vala"
		while (TRUE) {
#line 905 "ArchiveManager.c"
			gint _tmp38_;
			guint _tmp39_;
			gchar* filepath = NULL;
			FontManagerStringSet* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			GFile* file = NULL;
			const gchar* _tmp43_;
			GFile* _tmp44_;
#line 140 "../src/font-manager/ArchiveManager.vala"
			_filepath_index = _filepath_index + 1;
#line 140 "../src/font-manager/ArchiveManager.vala"
			_tmp38_ = _filepath_index;
#line 140 "../src/font-manager/ArchiveManager.vala"
			_tmp39_ = _filepath_size;
#line 140 "../src/font-manager/ArchiveManager.vala"
			if (!(((guint) _tmp38_) < _tmp39_)) {
#line 140 "../src/font-manager/ArchiveManager.vala"
				break;
#line 925 "ArchiveManager.c"
			}
#line 140 "../src/font-manager/ArchiveManager.vala"
			_tmp40_ = _filepath_list;
#line 140 "../src/font-manager/ArchiveManager.vala"
			_tmp41_ = font_manager_string_set_get (_tmp40_, (guint) _filepath_index);
#line 140 "../src/font-manager/ArchiveManager.vala"
			_tmp42_ = g_strdup (_tmp41_);
#line 140 "../src/font-manager/ArchiveManager.vala"
			filepath = _tmp42_;
#line 141 "../src/font-manager/ArchiveManager.vala"
			_tmp43_ = filepath;
#line 141 "../src/font-manager/ArchiveManager.vala"
			_tmp44_ = g_file_new_for_path (_tmp43_);
#line 141 "../src/font-manager/ArchiveManager.vala"
			file = _tmp44_;
#line 941 "ArchiveManager.c"
			{
				GFileInfo* file_info = NULL;
				GFile* _tmp45_;
				GFileInfo* _tmp46_;
				GFileType file_type = 0;
				GFileInfo* _tmp47_;
#line 143 "../src/font-manager/ArchiveManager.vala"
				_tmp45_ = file;
#line 143 "../src/font-manager/ArchiveManager.vala"
				_tmp46_ = g_file_query_info (_tmp45_, "*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 143 "../src/font-manager/ArchiveManager.vala"
				file_info = _tmp46_;
#line 143 "../src/font-manager/ArchiveManager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 956 "ArchiveManager.c"
					goto __catch0_g_error;
				}
#line 144 "../src/font-manager/ArchiveManager.vala"
				_tmp47_ = file_info;
#line 144 "../src/font-manager/ArchiveManager.vala"
				file_type = g_file_info_get_file_type (_tmp47_);
#line 145 "../src/font-manager/ArchiveManager.vala"
				if (file_type == G_FILE_TYPE_REGULAR) {
#line 965 "ArchiveManager.c"
					struct archive* _tmp48_;
					GFile* _tmp49_;
					GFileInfo* _tmp50_;
					const gchar* _tmp51_;
#line 146 "../src/font-manager/ArchiveManager.vala"
					_tmp48_ = archive;
#line 146 "../src/font-manager/ArchiveManager.vala"
					_tmp49_ = file;
#line 146 "../src/font-manager/ArchiveManager.vala"
					_tmp50_ = file_info;
#line 146 "../src/font-manager/ArchiveManager.vala"
					_tmp51_ = root;
#line 146 "../src/font-manager/ArchiveManager.vala"
					font_manager_archive_manager_add_data (self, _tmp48_, _tmp49_, _tmp50_, _tmp51_);
#line 980 "ArchiveManager.c"
				} else {
#line 147 "../src/font-manager/ArchiveManager.vala"
					if (file_type == G_FILE_TYPE_DIRECTORY) {
#line 984 "ArchiveManager.c"
						struct archive* _tmp52_;
						GFile* _tmp53_;
						GFileInfo* _tmp54_;
						const gchar* _tmp55_;
#line 148 "../src/font-manager/ArchiveManager.vala"
						_tmp52_ = archive;
#line 148 "../src/font-manager/ArchiveManager.vala"
						_tmp53_ = file;
#line 148 "../src/font-manager/ArchiveManager.vala"
						_tmp54_ = file_info;
#line 148 "../src/font-manager/ArchiveManager.vala"
						_tmp55_ = root;
#line 148 "../src/font-manager/ArchiveManager.vala"
						font_manager_archive_manager_add_directory (self, _tmp52_, _tmp53_, _tmp54_, _tmp55_);
#line 999 "ArchiveManager.c"
					}
				}
#line 142 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (file_info);
#line 1004 "ArchiveManager.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GError* _tmp56_;
				const gchar* _tmp57_;
#line 142 "../src/font-manager/ArchiveManager.vala"
				e = _inner_error0_;
#line 142 "../src/font-manager/ArchiveManager.vala"
				_inner_error0_ = NULL;
#line 150 "../src/font-manager/ArchiveManager.vala"
				_tmp56_ = e;
#line 150 "../src/font-manager/ArchiveManager.vala"
				_tmp57_ = _tmp56_->message;
#line 150 "../src/font-manager/ArchiveManager.vala"
				g_critical ("ArchiveManager.vala:150: %s", _tmp57_);
#line 151 "../src/font-manager/ArchiveManager.vala"
				result = FALSE;
#line 151 "../src/font-manager/ArchiveManager.vala"
				_g_error_free0 (e);
#line 151 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (file);
#line 151 "../src/font-manager/ArchiveManager.vala"
				_g_free0 (filepath);
#line 151 "../src/font-manager/ArchiveManager.vala"
				_g_free0 (filename);
#line 151 "../src/font-manager/ArchiveManager.vala"
				_g_free0 (root);
#line 151 "../src/font-manager/ArchiveManager.vala"
				_archive_write_free0 (archive);
#line 151 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (output_dir);
#line 151 "../src/font-manager/ArchiveManager.vala"
				return result;
#line 1040 "ArchiveManager.c"
			}
			__finally0:
#line 142 "../src/font-manager/ArchiveManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1045 "ArchiveManager.c"
				gboolean _tmp58_ = FALSE;
#line 142 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (file);
#line 142 "../src/font-manager/ArchiveManager.vala"
				_g_free0 (filepath);
#line 142 "../src/font-manager/ArchiveManager.vala"
				_g_free0 (filename);
#line 142 "../src/font-manager/ArchiveManager.vala"
				_g_free0 (root);
#line 142 "../src/font-manager/ArchiveManager.vala"
				_archive_write_free0 (archive);
#line 142 "../src/font-manager/ArchiveManager.vala"
				_g_object_unref0 (output_dir);
#line 142 "../src/font-manager/ArchiveManager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../src/font-manager/ArchiveManager.vala"
				g_clear_error (&_inner_error0_);
#line 142 "../src/font-manager/ArchiveManager.vala"
				return _tmp58_;
#line 1065 "ArchiveManager.c"
			}
#line 140 "../src/font-manager/ArchiveManager.vala"
			_g_object_unref0 (file);
#line 140 "../src/font-manager/ArchiveManager.vala"
			_g_free0 (filepath);
#line 1071 "ArchiveManager.c"
		}
	}
#line 155 "../src/font-manager/ArchiveManager.vala"
	_tmp59_ = archive;
#line 155 "../src/font-manager/ArchiveManager.vala"
	if (archive_write_close (_tmp59_) != ARCHIVE_OK) {
#line 1078 "ArchiveManager.c"
		const gchar* _tmp60_;
		struct archive* _tmp61_;
		const gchar* _tmp62_;
		struct archive* _tmp63_;
#line 156 "../src/font-manager/ArchiveManager.vala"
		_tmp60_ = filename;
#line 156 "../src/font-manager/ArchiveManager.vala"
		_tmp61_ = archive;
#line 156 "../src/font-manager/ArchiveManager.vala"
		_tmp62_ = archive_error_string (_tmp61_);
#line 156 "../src/font-manager/ArchiveManager.vala"
		_tmp63_ = archive;
#line 156 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:156: Error closing '%s' : %s (%d)", _tmp60_, _tmp62_, archive_errno (_tmp63_));
#line 157 "../src/font-manager/ArchiveManager.vala"
		result = FALSE;
#line 157 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (filename);
#line 157 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (root);
#line 157 "../src/font-manager/ArchiveManager.vala"
		_archive_write_free0 (archive);
#line 157 "../src/font-manager/ArchiveManager.vala"
		_g_object_unref0 (output_dir);
#line 157 "../src/font-manager/ArchiveManager.vala"
		return result;
#line 1105 "ArchiveManager.c"
	}
#line 160 "../src/font-manager/ArchiveManager.vala"
	result = TRUE;
#line 160 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (filename);
#line 160 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (root);
#line 160 "../src/font-manager/ArchiveManager.vala"
	_archive_write_free0 (archive);
#line 160 "../src/font-manager/ArchiveManager.vala"
	_g_object_unref0 (output_dir);
#line 160 "../src/font-manager/ArchiveManager.vala"
	return result;
#line 1119 "ArchiveManager.c"
}

static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
#line 201 "../src/font-manager/ArchiveManager.vala"
	if (length > 0) {
#line 201 "../src/font-manager/ArchiveManager.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 1130 "ArchiveManager.c"
	}
#line 201 "../src/font-manager/ArchiveManager.vala"
	return NULL;
#line 1134 "ArchiveManager.c"
}

gboolean
font_manager_archive_manager_extract (FontManagerArchiveManager* self,
                                      GFile* file,
                                      GFile* dest_dir)
{
	int EXTRACT_FLAGS = 0;
	struct archive* archive = NULL;
	struct archive* _tmp0_;
	struct archive* extractor = NULL;
	struct archive* _tmp1_;
	struct archive* _tmp2_;
	struct archive* _tmp3_;
	struct archive* _tmp4_;
	struct archive* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* filepath = NULL;
	gchar* _tmp8_;
	struct archive* _tmp9_;
	const gchar* _tmp10_;
	struct archive_entry* entry = NULL;
	int last_result = 0;
	gboolean result;
#line 163 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 163 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (dest_dir != NULL, FALSE);
#line 165 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (g_file_query_exists (file, NULL), FALSE);
#line 166 "../src/font-manager/ArchiveManager.vala"
	g_return_val_if_fail (g_file_query_exists (dest_dir, NULL), FALSE);
#line 169 "../src/font-manager/ArchiveManager.vala"
	EXTRACT_FLAGS = ARCHIVE_EXTRACT_TIME;
#line 170 "../src/font-manager/ArchiveManager.vala"
	EXTRACT_FLAGS |= ARCHIVE_EXTRACT_PERM;
#line 171 "../src/font-manager/ArchiveManager.vala"
	EXTRACT_FLAGS |= ARCHIVE_EXTRACT_ACL;
#line 172 "../src/font-manager/ArchiveManager.vala"
	EXTRACT_FLAGS |= ARCHIVE_EXTRACT_FFLAGS;
#line 174 "../src/font-manager/ArchiveManager.vala"
	_tmp0_ = archive_read_new ();
#line 174 "../src/font-manager/ArchiveManager.vala"
	archive = _tmp0_;
#line 175 "../src/font-manager/ArchiveManager.vala"
	_tmp1_ = archive_write_disk_new ();
#line 175 "../src/font-manager/ArchiveManager.vala"
	extractor = _tmp1_;
#line 176 "../src/font-manager/ArchiveManager.vala"
	_tmp2_ = archive;
#line 176 "../src/font-manager/ArchiveManager.vala"
	archive_read_support_format_all (_tmp2_);
#line 177 "../src/font-manager/ArchiveManager.vala"
	_tmp3_ = archive;
#line 177 "../src/font-manager/ArchiveManager.vala"
	archive_read_support_filter_all (_tmp3_);
#line 178 "../src/font-manager/ArchiveManager.vala"
	_tmp4_ = extractor;
#line 178 "../src/font-manager/ArchiveManager.vala"
	archive_write_disk_set_options (_tmp4_, EXTRACT_FLAGS);
#line 179 "../src/font-manager/ArchiveManager.vala"
	_tmp5_ = extractor;
#line 179 "../src/font-manager/ArchiveManager.vala"
	archive_write_disk_set_standard_lookup (_tmp5_);
#line 181 "../src/font-manager/ArchiveManager.vala"
	_tmp6_ = g_file_get_path (dest_dir);
#line 181 "../src/font-manager/ArchiveManager.vala"
	_tmp7_ = _tmp6_;
#line 181 "../src/font-manager/ArchiveManager.vala"
	g_chdir (_tmp7_);
#line 181 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (_tmp7_);
#line 182 "../src/font-manager/ArchiveManager.vala"
	_tmp8_ = g_file_get_path (file);
#line 182 "../src/font-manager/ArchiveManager.vala"
	filepath = _tmp8_;
#line 184 "../src/font-manager/ArchiveManager.vala"
	_tmp9_ = archive;
#line 184 "../src/font-manager/ArchiveManager.vala"
	_tmp10_ = filepath;
#line 184 "../src/font-manager/ArchiveManager.vala"
	if (archive_read_open_filename (_tmp9_, _tmp10_, (gsize) 10240) != ARCHIVE_OK) {
#line 1220 "ArchiveManager.c"
		const gchar* _tmp11_;
		struct archive* _tmp12_;
		const gchar* _tmp13_;
		struct archive* _tmp14_;
#line 185 "../src/font-manager/ArchiveManager.vala"
		_tmp11_ = filepath;
#line 185 "../src/font-manager/ArchiveManager.vala"
		_tmp12_ = archive;
#line 185 "../src/font-manager/ArchiveManager.vala"
		_tmp13_ = archive_error_string (_tmp12_);
#line 185 "../src/font-manager/ArchiveManager.vala"
		_tmp14_ = archive;
#line 185 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:185: Error opening '%s' : %s (%d)", _tmp11_, _tmp13_, archive_errno (_tmp14_));
#line 186 "../src/font-manager/ArchiveManager.vala"
		result = FALSE;
#line 186 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (filepath);
#line 186 "../src/font-manager/ArchiveManager.vala"
		_archive_write_free0 (extractor);
#line 186 "../src/font-manager/ArchiveManager.vala"
		_archive_read_free0 (archive);
#line 186 "../src/font-manager/ArchiveManager.vala"
		return result;
#line 1245 "ArchiveManager.c"
	}
#line 191 "../src/font-manager/ArchiveManager.vala"
	while (TRUE) {
#line 1249 "ArchiveManager.c"
		struct archive* _tmp15_;
		struct archive_entry* _tmp16_ = NULL;
		int _tmp17_;
		struct archive* _tmp18_;
		struct archive_entry* _tmp19_;
		off_t offset = {0};
		guint8* buffer = NULL;
		gint buffer_length1;
		gint _buffer_size_;
#line 191 "../src/font-manager/ArchiveManager.vala"
		_tmp15_ = archive;
#line 191 "../src/font-manager/ArchiveManager.vala"
		_tmp17_ = archive_read_next_header (_tmp15_, &_tmp16_);
#line 191 "../src/font-manager/ArchiveManager.vala"
		entry = _tmp16_;
#line 191 "../src/font-manager/ArchiveManager.vala"
		last_result = _tmp17_;
#line 191 "../src/font-manager/ArchiveManager.vala"
		if (!(last_result == ARCHIVE_OK)) {
#line 191 "../src/font-manager/ArchiveManager.vala"
			break;
#line 1271 "ArchiveManager.c"
		}
#line 193 "../src/font-manager/ArchiveManager.vala"
		_tmp18_ = extractor;
#line 193 "../src/font-manager/ArchiveManager.vala"
		_tmp19_ = entry;
#line 193 "../src/font-manager/ArchiveManager.vala"
		if (archive_write_header (_tmp18_, _tmp19_) != ARCHIVE_OK) {
#line 1279 "ArchiveManager.c"
			const gchar* archived_path = NULL;
			struct archive_entry* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 194 "../src/font-manager/ArchiveManager.vala"
			_tmp20_ = entry;
#line 194 "../src/font-manager/ArchiveManager.vala"
			_tmp21_ = archive_entry_pathname (_tmp20_);
#line 194 "../src/font-manager/ArchiveManager.vala"
			archived_path = _tmp21_;
#line 195 "../src/font-manager/ArchiveManager.vala"
			_tmp22_ = archived_path;
#line 195 "../src/font-manager/ArchiveManager.vala"
			_tmp23_ = string_to_string (_tmp22_);
#line 195 "../src/font-manager/ArchiveManager.vala"
			_tmp24_ = g_strconcat ("Failed to write header entry for ", _tmp23_, NULL);
#line 195 "../src/font-manager/ArchiveManager.vala"
			_tmp25_ = _tmp24_;
#line 195 "../src/font-manager/ArchiveManager.vala"
			g_critical ("ArchiveManager.vala:195: %s", _tmp25_);
#line 195 "../src/font-manager/ArchiveManager.vala"
			_g_free0 (_tmp25_);
#line 196 "../src/font-manager/ArchiveManager.vala"
			continue;
#line 1307 "ArchiveManager.c"
		}
#line 200 "../src/font-manager/ArchiveManager.vala"
		buffer = NULL;
#line 200 "../src/font-manager/ArchiveManager.vala"
		buffer_length1 = 0;
#line 200 "../src/font-manager/ArchiveManager.vala"
		_buffer_size_ = buffer_length1;
#line 201 "../src/font-manager/ArchiveManager.vala"
		while (TRUE) {
#line 1317 "ArchiveManager.c"
			struct archive* _tmp26_;
			guint8* _tmp27_ = NULL;
			size_t _tmp28_ = 0;
			la_int64_t _tmp29_ = {0};
			int _tmp30_;
			guint8* _tmp31_;
			gint _tmp31__length1;
			struct archive* _tmp32_;
			guint8* _tmp33_;
			gint _tmp33__length1;
#line 201 "../src/font-manager/ArchiveManager.vala"
			_tmp26_ = archive;
#line 201 "../src/font-manager/ArchiveManager.vala"
			_tmp30_ = archive_read_data_block (_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_);
#line 201 "../src/font-manager/ArchiveManager.vala"
			buffer = (g_free (buffer), NULL);
#line 201 "../src/font-manager/ArchiveManager.vala"
			_tmp31_ = (_tmp27_ != NULL) ? _vala_array_dup1 (_tmp27_, _tmp28_) : _tmp27_;
#line 201 "../src/font-manager/ArchiveManager.vala"
			_tmp31__length1 = _tmp28_;
#line 201 "../src/font-manager/ArchiveManager.vala"
			buffer = _tmp31_;
#line 201 "../src/font-manager/ArchiveManager.vala"
			buffer_length1 = _tmp31__length1;
#line 201 "../src/font-manager/ArchiveManager.vala"
			_buffer_size_ = buffer_length1;
#line 201 "../src/font-manager/ArchiveManager.vala"
			offset = (off_t) _tmp29_;
#line 201 "../src/font-manager/ArchiveManager.vala"
			if (!(_tmp30_ == ARCHIVE_OK)) {
#line 201 "../src/font-manager/ArchiveManager.vala"
				break;
#line 1350 "ArchiveManager.c"
			}
#line 202 "../src/font-manager/ArchiveManager.vala"
			_tmp32_ = extractor;
#line 202 "../src/font-manager/ArchiveManager.vala"
			_tmp33_ = buffer;
#line 202 "../src/font-manager/ArchiveManager.vala"
			_tmp33__length1 = buffer_length1;
#line 202 "../src/font-manager/ArchiveManager.vala"
			if (archive_write_data_block (_tmp32_, _tmp33_, (size_t) _tmp33__length1, (la_int64_t) offset) < ((gssize) ARCHIVE_OK)) {
#line 203 "../src/font-manager/ArchiveManager.vala"
				break;
#line 1362 "ArchiveManager.c"
			}
		}
#line 191 "../src/font-manager/ArchiveManager.vala"
		buffer = (g_free (buffer), NULL);
#line 1367 "ArchiveManager.c"
	}
#line 207 "../src/font-manager/ArchiveManager.vala"
	if (last_result != ARCHIVE_EOF) {
#line 1371 "ArchiveManager.c"
		const gchar* _tmp34_;
		struct archive* _tmp35_;
		const gchar* _tmp36_;
		struct archive* _tmp37_;
#line 208 "../src/font-manager/ArchiveManager.vala"
		_tmp34_ = filepath;
#line 208 "../src/font-manager/ArchiveManager.vala"
		_tmp35_ = archive;
#line 208 "../src/font-manager/ArchiveManager.vala"
		_tmp36_ = archive_error_string (_tmp35_);
#line 208 "../src/font-manager/ArchiveManager.vala"
		_tmp37_ = archive;
#line 208 "../src/font-manager/ArchiveManager.vala"
		g_critical ("ArchiveManager.vala:208: Error extracting '%s' : %s (%d)", _tmp34_, _tmp36_, archive_errno (_tmp37_));
#line 209 "../src/font-manager/ArchiveManager.vala"
		result = FALSE;
#line 209 "../src/font-manager/ArchiveManager.vala"
		_g_free0 (filepath);
#line 209 "../src/font-manager/ArchiveManager.vala"
		_archive_write_free0 (extractor);
#line 209 "../src/font-manager/ArchiveManager.vala"
		_archive_read_free0 (archive);
#line 209 "../src/font-manager/ArchiveManager.vala"
		return result;
#line 1396 "ArchiveManager.c"
	}
#line 212 "../src/font-manager/ArchiveManager.vala"
	result = TRUE;
#line 212 "../src/font-manager/ArchiveManager.vala"
	_g_free0 (filepath);
#line 212 "../src/font-manager/ArchiveManager.vala"
	_archive_write_free0 (extractor);
#line 212 "../src/font-manager/ArchiveManager.vala"
	_archive_read_free0 (archive);
#line 212 "../src/font-manager/ArchiveManager.vala"
	return result;
#line 1408 "ArchiveManager.c"
}

FontManagerArchiveManager*
font_manager_archive_manager_construct (GType object_type)
{
	FontManagerArchiveManager * self = NULL;
#line 54 "../src/font-manager/ArchiveManager.vala"
	self = (FontManagerArchiveManager*) g_object_new (object_type, NULL);
#line 54 "../src/font-manager/ArchiveManager.vala"
	return self;
#line 1419 "ArchiveManager.c"
}

FontManagerArchiveManager*
font_manager_archive_manager_new (void)
{
#line 54 "../src/font-manager/ArchiveManager.vala"
	return font_manager_archive_manager_construct (FONT_MANAGER_TYPE_ARCHIVE_MANAGER);
#line 1427 "ArchiveManager.c"
}

static void
font_manager_archive_manager_class_init (FontManagerArchiveManagerClass * klass,
                                         gpointer klass_data)
{
#line 54 "../src/font-manager/ArchiveManager.vala"
	font_manager_archive_manager_parent_class = g_type_class_peek_parent (klass);
#line 1436 "ArchiveManager.c"
}

static void
font_manager_archive_manager_instance_init (FontManagerArchiveManager * self,
                                            gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
font_manager_archive_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerArchiveManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_archive_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerArchiveManager), 0, (GInstanceInitFunc) font_manager_archive_manager_instance_init, NULL };
	GType font_manager_archive_manager_type_id;
	font_manager_archive_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerArchiveManager", &g_define_type_info, 0);
	return font_manager_archive_manager_type_id;
}

GType
font_manager_archive_manager_get_type (void)
{
	static volatile gsize font_manager_archive_manager_type_id__once = 0;
	if (g_once_init_enter (&font_manager_archive_manager_type_id__once)) {
		GType font_manager_archive_manager_type_id;
		font_manager_archive_manager_type_id = font_manager_archive_manager_get_type_once ();
		g_once_init_leave (&font_manager_archive_manager_type_id__once, font_manager_archive_manager_type_id);
	}
	return font_manager_archive_manager_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

